# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file RobotMoveLocusRDBGui.py
 @brief ロボット移動軌跡表示で使用するRDB制御GUI
 @date $Date$

 @author East Japan Accounting Center Co.,Ltd.

 (c)2017 The University of Aizu
 This software is released under the New BSD License.

"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

# add import
import json
import collections as cl
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import Qt, QObject, pyqtSignal, QTime, QDateTime
from RobotMoveLocusRDBGuiDesign import Ui_MainWindow

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
robotmovelocusrdbgui_spec = ["implementation_id", "RobotMoveLocusRDBGui",
                             "type_name",         "RobotMoveLocusRDBGui",
                             "description",       "ロボット移動軌跡表示で使用するRDB制御GUI",
                             "version",           "1.0.0",
                             "vendor",            "EAC",
                             "category",          "GUI",
                             "activity_type",     "STATIC",
                             "max_instance",      "1",
                             "language",          "Python",
                             "lang_type",         "SCRIPT",
                             ""]
# </rtc-template>

#
# @class RobotMoveLocusRDBGui
# @brief ロボット移動軌跡表示で使用するRDB制御GUI
#
# 別紙"機能仕様書_ロボット移動軌跡RDB GUIRTC"参照
#
# 別紙"機能仕様書_ロボット移動軌跡RDB GUIRTC"参照
#
# 別紙"機能仕様書_ロボット移動軌跡RDB GUIRTC"参照
#
# 別紙"機能仕様書_ロボット移動軌跡RDB GUIRTC"参照
#
#


class RobotMoveLocusRDBGui(OpenRTM_aist.DataFlowComponentBase):

    #
    # @brief constructor
    # @param manager Maneger Object
    #

    def __init__(self, manager):
        OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

        self._d_inRobotMoveLocusRDBSts = RTC.TimedString(RTC.Time(0, 0), "")
        """
        ロボット移動軌跡RDBの状態を通知する
        ※本GUIのキー抑止に使用
        - Type: RTC::TimedString
        - Number: 1
        - Semantics: -
        - Unit: -
        - Frequency: RDB読み込み完了時
        - Operation Cycle: RDB読み込み完了時
        """
        self._inRobotMoveLocusRDBStsIn = OpenRTM_aist.InPort(
            "inRobotMoveLocusRDBSts", self._d_inRobotMoveLocusRDBSts)
        self._d_outDBSearchParam = RTC.TimedString(RTC.Time(0, 0), "")
        """
        パラメータ（collection、ロボットID、取得開始日時、終了日時）の設定を行う
        - Type: RTC::TimedString
        - Number: 1
        - Semantics: -
         - Unit: -
         - Frequency: ユーザー操作時
         - Operation Cycle: ユーザー操作時
         """
        self._outDBSearchParamOut = OpenRTM_aist.OutPort(
            "outDBSearchParam", self._d_outDBSearchParam)

        # initialize of configuration-data.
        # <rtc-template block="init_conf_param">

        # </rtc-template>

    #
    # ロボット移動軌跡表示RDB制御用GUIの初期化処理
    #
    # The initialize action (on CREATED->ALIVE transition)
    # formaer rtc_init_entry()
    #
    # @return RTC::ReturnCode_t
    #
    # @pre -
    # @post -
    #
    def onInitialize(self):
        # Bind variables and configuration variable

        # Set InPort buffers
        self.addInPort(
            "inRobotMoveLocusRDBSts", self._inRobotMoveLocusRDBStsIn)

        # Set OutPort buffers
        self.addOutPort("outDBSearchParam", self._outDBSearchParamOut)

        # Set service provider to Ports

        # Set service consumers to Ports

        # Set CORBA Service Ports

        print "[debug]onInitialize!!"
        return RTC.RTC_OK

        #
        # ロボット移動軌跡表示RDB制御用GUIの終了処理
        #
        # The finalize action (on ALIVE->END transition)
        # formaer rtc_exiting_entry()
        #
        # @return RTC::ReturnCode_t

        # @pre -
        # @post -
        #
    def onFinalize(self):
        print "[debug]onFinalize!!"
        return RTC.RTC_OK

    #
    #
    # The startup action when ExecutionContext startup
    # former rtc_starting_entry()
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    # def onStartup(self, ec_id):
    #
    # return RTC.RTC_OK

    #
    #
    # The shutdown action when ExecutionContext stop
    # former rtc_stopping_entry()
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    # def onShutdown(self, ec_id):
    #
    # return RTC.RTC_OK

        #
        # ロボット移動軌跡表示RDB制御用GUIの開始処理
        #
        # The activated action (Active state entry action)
        # former rtc_active_entry()
        #
        # @param ec_id target ExecutionContext Id
        #
        # @return RTC::ReturnCode_t
        #
        # @pre -
        # @post -
        #
    def onActivated(self, ec_id):
        print "[debug]onActivated!!"
        self.varinit()

        return RTC.RTC_OK

        #
        # ロボット移動軌跡表示RDB制御用GUIの停止処理
        #
        # The deactivated action (Active state exit action)
        # former rtc_active_exit()
        #
        # @param ec_id target ExecutionContext Id
        #
        # @return RTC::ReturnCode_t
        #
        # @pre -
        # @post -
        #
    def onDeactivated(self, ec_id):
        print "[debug]onDeactivated!!"
        self.varinit()
        # ボタン抑止解除
        g_form.disableGui()

        return RTC.RTC_OK

        #
        # ロボット移動軌跡表示RDB制御用GUIの周期処理
        #
        # The execution action that is invoked periodically
        # former rtc_active_do()
        #
        # @param ec_id target ExecutionContext Id
        #
        # @return RTC::ReturnCode_t
        #
        # @pre -
        # @post -
        #
    def onExecute(self, ec_id):
        # RDBステータスの確認
        if self.chk_robotmovelocus_rdb_sts() is False:

            # ボタン押下の場合
            if self._request_set:
                # Jsonデータ出力
                self.output_rdb_parameters()
                self._request_set = False
            else:
                # ボタン抑止解除
                g_form.enableGui()

        return RTC.RTC_OK

        ##
        # ロボット移動軌跡表示RDB制御用GUIのエラー遷移処理
        #
        # The aborting action when main logic error occurred.
        # former rtc_aborting_entry()
        #
        # @param ec_id target ExecutionContext Id
        #
        # @return RTC::ReturnCode_t
        #
        # @pre -
        # @post -
        #
    def onAborting(self, ec_id):
        print "[debug]onAborting!!"
        return RTC.RTC_OK

    #
    #
    # The error action in ERROR state
    # former rtc_error_do()
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    # def onError(self, ec_id):
    #
    # return RTC.RTC_OK

    #
    #
    # The reset action that is invoked resetting
    # This is same but different the former rtc_init_entry()
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    # def onReset(self, ec_id):
    #
    # return RTC.RTC_OK

    #
    #
    # The state update action that is invoked after onExecute() action
    # no corresponding operation exists in OpenRTm-aist-0.2.0
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #

    #
    # def onStateUpdate(self, ec_id):
    #
    # return RTC.RTC_OK

    #
    #
    # The action that is invoked when execution context's rate is changed
    # no corresponding operation exists in OpenRTm-aist-0.2.0
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    # def onRateChanged(self, ec_id):
    #
    # return RTC.RTC_OK
# ====================================================================
#    変数定義
# ====================================================================
    _input_db_collection = ""
    _input_robot_id = ""
    _input_start_datetime = ""
    _input_end_datetime = ""
    _request_set = False
    _rdb_sts = "RDB_STS_INIT"

# ===================================================================
#  処　理：メンバ変数初期化処理
#  戻り値：なし
# ===================================================================
    def varinit(self):
        self._input_db_collection = ""
        self._input_robot_id = ""
        self._input_start_datetime = ""
        self._input_end_datetime = ""
        self._request_set = False
        self._rdb_sts = "RDB_STS_INIT"

# ===================================================================
#  処　理：RDB状態監視処理
#  戻り値：Trur:RDB動作中、False：RDB動作していない
# ===================================================================
    def chk_robotmovelocus_rdb_sts(self):
        ret = True

        if self._inRobotMoveLocusRDBStsIn.isNew():
            _result = self._inRobotMoveLocusRDBStsIn.read()
            self._rdb_sts = _result.data
            print "[debug]rdb_sts = ", self._rdb_sts

        if self._rdb_sts == "RDB_STS_NO_ACTION":
            ret = False

        return ret


# ===================================================================
#  処　理：RDB読み込みパラメータデータポート出力処理
#  戻り値：なし
# ===================================================================
    def output_rdb_parameters(self):

        data = cl.OrderedDict()  # 順序付き辞書
        data["DBCollection"] = self._input_db_collection
        data["RobotID"] = self._input_robot_id
        data["StartDateTime"] = self._input_start_datetime
        data["EndDateTime"] = self._input_end_datetime

        jsonString = json.dumps(data, sort_keys=False, indent=4)
        print "jsonString = ", jsonString
        self._d_outDBSearchParam.data = jsonString
        self._outDBSearchParamOut.write()


# ==============================================================================
#    GUI制御クラス
# ==============================================================================
class MainWindow(QtGui.QMainWindow):
    # シグナル生成
    trigger = pyqtSignal()

    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        QtGui.QWidget.__init__(self, parent=parent)

        # GUi インスタンス生成
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        self.disableGui()

        # RTMクラス
        self._rtm = None

        # GUIイベント設定
        QtCore.QObject.connect(self.ui.pushButton_Start,
                               QtCore.SIGNAL("clicked()"),
                               self.btn_Start_clicked)

# ===================================================================
#  処　理：startキー押下処理
#  戻り値：なし
# ===================================================================
    def btn_Start_clicked(self):
        print "btn_Start_clicked!!!"

        if (self.ui.lineEdit_DBCollection.text() == ""):
            print "[warning]DB Collection isnot entered!!"
            self._rtm._request_set = False
        elif (self.ui.lineEdit_RobotID.text() == ""):
            print "[warning]Robot ID isnot entered!!"
            self._rtm._request_set = False
        elif self.ui.dateTimeEdit_Start.dateTime() > self.ui.dateTimeEdit_End.dateTime():
            print "[warning]Start date and time > End date and time!!"
        else:
            self._rtm._input_db_collection = str(
                self.ui.lineEdit_DBCollection.text())
            print "DB Collection = ", self._rtm._input_db_collection

            self._rtm._input_robot_id = str(
                self.ui.lineEdit_RobotID.text())
            print "Robot ID = ", self._rtm._input_robot_id

            self._rtm._input_start_datetime = self.get_str_date_time(
                self.ui.dateTimeEdit_Start)
            print "Start Datetime = ", self._rtm._input_start_datetime

            self._rtm._input_end_datetime = self.get_str_date_time(
                self.ui.dateTimeEdit_End)
            print "End Datetime = ", self._rtm._input_end_datetime

            self._rtm._request_set = True
            self.disableGui()

# ===================================================================
#  処　理：日時取得処理（RDBインターフェースに従い一部文字列置換を行う）
#  戻り値：なし
# ===================================================================
    def get_str_date_time(self, _datetimeedit):
        date = _datetimeedit.dateTime()
        date_1 = date.toString(Qt.ISODate)
        str_date = str(date_1)
        str_date = str_date.replace("T", " ")  # 余分なタイムの"T"をスペースに置換

        return str_date

# ===================================================================
#  処　理：GUI操作禁止処理
#  戻り値：なし
# ===================================================================
    def disableGui(self):
        self.ui.setDisableUi(self)

# ===================================================================
#  処　理：GUI操作許可処理
#  戻り値：なし
# ===================================================================
    def enableGui(self):
        self.ui.setEnableUi(self)

# ====================================================================
#       コンポーネントクラス設定
# ====================================================================
    def set_rtm_cmp(self, comp):
        self._rtm = comp
        return


# ================================================================================
def main():
    mgr = OpenRTM_aist.Manager.init(sys.argv)
    mgr.activateManager()

    profile = OpenRTM_aist.Properties(defaults_str=robotmovelocusrdbgui_spec)
    mgr.registerFactory(profile,
                        RobotMoveLocusRDBGui,
                        OpenRTM_aist.Delete)

    # Create a component
    comp = mgr.createComponent("RobotMoveLocusRDBGui")
    mgr.runManager(True)
    app = QtGui.QApplication(sys.argv)

    # GUIクラス 設定
    global g_form
    g_form = MainWindow()
    g_form.set_rtm_cmp(comp)
    g_form.show()

    sys.exit(app.exec_())
    mgr.shutdown()


if __name__ == "__main__":
    main()
